/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "about.h"
#include "version.h"
#include <wx/textfile.h>
#include <wx/stdpaths.h>

////@begin XPM images
////@end XPM images


/*!
 * About type definition
 */

IMPLEMENT_DYNAMIC_CLASS( About, wxDialog )


/*!
 * About event table definition
 */

BEGIN_EVENT_TABLE( About, wxDialog )

////@begin About event table entries
    EVT_BUTTON( ID_BUTTON_ABOUT_CLOSE, About::OnButtonAboutCloseClick )

////@end About event table entries

END_EVENT_TABLE()


/*!
 * About constructors
 */

About::About()
{
    Init();
}

About::About( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * About creator
 */

bool About::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin About creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end About creation
    return true;
}


/*!
 * About destructor
 */

About::~About()
{
////@begin About destruction
////@end About destruction
}


/*!
 * Member initialisation
 */

void About::Init()
{
////@begin About member initialisation
    m_btnClose = NULL;
////@end About member initialisation
}


/*!
 * Control creation for About
 */

void About::CreateControls()
{    
////@begin About content construction
    About* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxHtmlWindow* itemHtmlWindow3 = new wxHtmlWindow;
    itemHtmlWindow3->Create( itemDialog1, ID_HTMLWINDOW, wxDefaultPosition, wxSize(450, 300), wxHW_SCROLLBAR_AUTO|wxSUNKEN_BORDER|wxHSCROLL|wxVSCROLL );
    itemBoxSizer2->Add(itemHtmlWindow3, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer4, 0, wxALIGN_RIGHT|wxALL, 5);

    m_btnClose = new wxButton;
    m_btnClose->Create( itemDialog1, ID_BUTTON_ABOUT_CLOSE, _("Close"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(m_btnClose, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

////@end About content construction
	wxString page (_T("<style type=\"text/css\"><!-- div {font-family: Arial, Helvetica, sans-serif} --></style>"));
	page.Append (_T("<div><img src=\"#DATA_PATH#/sitplus_logo_text_small_400x100.png\"><h2>"));
	page.Append (_("An interactive tool for people with cerebral palsy."));
	page.Append (_T("</h2><h3>v#APPVERSION#</h3><p>&copy; 2010 Cesar Mauri Loba & Associaci&oacute; Provincial de Par&agrave;lisi Cerebral (APPC) de Tarragona.</p><p>"));
	page.Append (_("With the support of:"));
	page.Append (_T("</p><p><img src=\"#DATA_PATH#/acciosocial.png\"></p><p><img src=\"#DATA_PATH#/tuajudes.png\"></p><p>"));
	page.Append (_("Thanks to:"));
	page.Append (_T("</p><br><p>"));
	
	wxTextFile thanksFile(wxStandardPaths::Get().GetDataDir().Append(_T("/THANKS")));
	if (thanksFile.Open())
	{
		wxString str;

		for ( str = thanksFile.GetFirstLine(); !thanksFile.Eof(); str = thanksFile.GetNextLine() )
		{	page.Append (str);
			page.Append (_T("<br>"));
		}
	}

	page.Append (_T("</p><p><strong>"));
	page.Append (_("See license.rtf file for license conditions."));
	page.Append (_T("</strong></p></div>"));

	page.Replace (_T("#DATA_PATH#"), wxStandardPaths::Get().GetDataDir(), true);
	page.Replace (_T("#APPVERSION#"), GetAppVersion(), true);
	itemHtmlWindow3->SetPage(page);
}


/*!
 * Should we show tooltips?
 */

bool About::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap About::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin About bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end About bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon About::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin About icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end About icon retrieval
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_ABOUT_CLOSE
 */

void About::OnButtonAboutCloseClick( wxCommandEvent& event )
{
////@begin wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_ABOUT_CLOSE in About.
    // Before editing this code, remove the block markers.
    EndModal(ID_BUTTON_ABOUT_CLOSE);
////@end wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_ABOUT_CLOSE in About. 
}

