/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

#ifndef _CAMDIALOG_H_
#define _CAMDIALOG_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/mdi.h"
#include "wx/statusbr.h"
////@end includes
#include <wx/thread.h>
#include "camwindow2.h"
#include "crvcamera.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxStatusBar;
class CCamWindow2;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CCAMDIALOG 10005
#define ID_STATUSBAR -1
#define ID_PANEL_CAMWIN 10068
#define SYMBOL_CCAMDIALOG_STYLE wxCAPTION|wxRESIZE_BORDER
#define SYMBOL_CCAMDIALOG_TITLE _("Camera Dialog")
#define SYMBOL_CCAMDIALOG_IDNAME ID_CCAMDIALOG
#define SYMBOL_CCAMDIALOG_SIZE wxDefaultSize
#define SYMBOL_CCAMDIALOG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CCamDialog class declaration
 */

class CCamDialog: public wxMDIChildFrame
{    
    DECLARE_CLASS( CCamDialog )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CCamDialog();
    CCamDialog( wxMDIParentFrame* parent, wxWindowID id = SYMBOL_CCAMDIALOG_IDNAME, const wxString& caption = SYMBOL_CCAMDIALOG_TITLE, const wxPoint& pos = SYMBOL_CCAMDIALOG_POSITION, const wxSize& size = SYMBOL_CCAMDIALOG_SIZE, long style = SYMBOL_CCAMDIALOG_STYLE );

    bool Create( wxMDIParentFrame* parent, wxWindowID id = SYMBOL_CCAMDIALOG_IDNAME, const wxString& caption = SYMBOL_CCAMDIALOG_TITLE, const wxPoint& pos = SYMBOL_CCAMDIALOG_POSITION, const wxSize& size = SYMBOL_CCAMDIALOG_SIZE, long style = SYMBOL_CCAMDIALOG_STYLE );

    /// Destructor
    ~CCamDialog();

private:
    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

//	void DrawCam (IplImage* pImg);
//	void SetCamera (CCamera* pCamera);
//	CCamWindow* GetCamWindow() { return m_pCamWindow; }

	// Update FPS meter
	enum EFPSCondition { GOOD, FAIR, POOR };
	void SetFPS (long value, EFPSCondition cond);
	void OnSetFPS( wxCommandEvent &event );

////@begin CCamDialog event handler declarations

    /// wxEVT_CLOSE_WINDOW event handler for ID_CCAMDIALOG
    void OnCloseWindow( wxCloseEvent& event );

////@end CCamDialog event handler declarations

////@begin CCamDialog member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CCamDialog member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CCamDialog member variables
    wxStatusBar* m_statusBar;
    CCamWindow2* m_camWindow;
////@end CCamDialog member variables

	wxMutex m_mutex;
};

#endif
    // _CAMDIALOG_H_
