/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "cameradialog2.h"
#include "cameracontroller.h"


////@begin XPM images
////@end XPM images


/*!
 * CameraDialog2 type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CameraDialog2, wxDialog )


/*!
 * CameraDialog2 event table definition
 */

BEGIN_EVENT_TABLE( CameraDialog2, wxDialog )

////@begin CameraDialog2 event table entries
    EVT_CLOSE( CameraDialog2::OnCloseWindow )

////@end CameraDialog2 event table entries

END_EVENT_TABLE()


/*!
 * CameraDialog2 constructors
 */

CameraDialog2::CameraDialog2()
{
    Init();
}

CameraDialog2::CameraDialog2( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CameraDialog2 creator
 */

bool CameraDialog2::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CameraDialog2 creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    Centre();
////@end CameraDialog2 creation
    return true;
}


/*!
 * CameraDialog2 destructor
 */

CameraDialog2::~CameraDialog2()
{
	CCameraController::getInstance()->UnregisterImageDrawer (m_camWindow);
////@begin CameraDialog2 destruction
////@end CameraDialog2 destruction
}


/*!
 * Member initialisation
 */

void CameraDialog2::Init()
{
////@begin CameraDialog2 member initialisation
    m_camWindow = NULL;
////@end CameraDialog2 member initialisation
}


/*!
 * Control creation for CameraDialog2
 */

void CameraDialog2::CreateControls()
{    
////@begin CameraDialog2 content construction
    CameraDialog2* itemDialog1 = this;

    m_camWindow = new CCamWindow2;
    m_camWindow->Create( itemDialog1, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL );

////@end CameraDialog2 content construction
	m_camWindow->SetReziseParent(true);
	CCameraController::getInstance()->RegisterImageDrawer (m_camWindow);
}


/*!
 * Should we show tooltips?
 */

bool CameraDialog2::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CameraDialog2::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CameraDialog2 bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CameraDialog2 bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CameraDialog2::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CameraDialog2 icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CameraDialog2 icon retrieval
}


/*!
 * wxEVT_CLOSE_WINDOW event handler for ID_CAMERADIALOG2
 */

void CameraDialog2::OnCloseWindow( wxCloseEvent& event )
{
    Destroy();
    event.Skip(false);
}

