/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////


#ifndef _PLAYWITHVOICEDIALOG_H_
#define _PLAYWITHVOICEDIALOG_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/mdi.h"
#include "wx/gbsizer.h"
#include "wx/statline.h"
////@end includes

#include "logexprange.h"
#include "pvoiceactivity.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_PLAYWITHVOICEDIALOG 10021
#define ID_BITMAPBUTTON_MICINPUT 10016
#define ID_SLIDER_MIC_INPUT 10022
#define ID_GAUGE_MIC_INPUT 10023
#define ID_BITMAPBUTTON_SOUNDOUTPUT 10017
#define ID_SLIDER_OUTPUT 10000
#define ID_GAUGE_OUTPUT 10001
#define ID_BITMAPBUTTON_REVERB 10026
#define ID_SLIDER_REVERB 10002
#define ID_TEXTCTRL_REVERB 10005
#define ID_BITMAPBUTTON_CHORUS 10006
#define ID_SLIDER_CHORUS 10010
#define ID_TEXTCTRL_CHORUS 10011
#define ID_BITMAPBUTTON_PITCHSHIFT 10009
#define ID_SLIDER_PITCHSHIFT 10007
#define ID_TEXTCTRL_PITCHSHIFT 10008
#define ID_BITMAPBUTTON_DISTORSION 10018
#define ID_SLIDER_DISTORSION 10019
#define ID_TEXTCTRL_DISTORSION 10025
#define ID_CHECKBOX_ROBOT 10014
#define ID_CHECKBOX_PHONE 10015
#define ID_CHECKBOX_HOWLINGREDUCTION 10027
#define ID_BITMAPBUTTON_ECHODELAY 10012
#define ID_SLIDER_ECHODELAY 10020
#define ID_TEXTCTRL_ECHODELAY 10024
#define ID_BITMAPBUTTON_ECHOPITCHSHIFT 10013
#define ID_SLIDER_ECHOPITCHSHIFT 10003
#define ID_TEXTCTRL_ECHOPITCHSHIFT 10004
#define SYMBOL_PLAYWITHVOICEDIALOG_STYLE wxCAPTION|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_PLAYWITHVOICEDIALOG_TITLE _("Playing with the Voice")
#define SYMBOL_PLAYWITHVOICEDIALOG_IDNAME ID_PLAYWITHVOICEDIALOG
#define SYMBOL_PLAYWITHVOICEDIALOG_SIZE wxSize(400, 300)
#define SYMBOL_PLAYWITHVOICEDIALOG_POSITION wxDefaultPosition
////@end control identifiers

#define TIMER_ID 12345

/*!
 * PlayWithVoiceDialog class declaration
 */

class PlayWithVoiceDialog: public wxMDIChildFrame
{    
    DECLARE_DYNAMIC_CLASS( PlayWithVoiceDialog )
    DECLARE_EVENT_TABLE()
public:
	// Singleton
	static PlayWithVoiceDialog* getInstance(wxMDIParentFrame* parent, wxWindowID id = SYMBOL_PLAYWITHVOICEDIALOG_IDNAME, const wxString& caption = SYMBOL_PLAYWITHVOICEDIALOG_TITLE, const wxPoint& pos = SYMBOL_PLAYWITHVOICEDIALOG_POSITION, const wxSize& size = SYMBOL_PLAYWITHVOICEDIALOG_SIZE, long style = SYMBOL_PLAYWITHVOICEDIALOG_STYLE );
	
private:
	static PlayWithVoiceDialog* g_single;

    /// Constructors
    PlayWithVoiceDialog();
    PlayWithVoiceDialog( wxMDIParentFrame* parent, wxWindowID id = SYMBOL_PLAYWITHVOICEDIALOG_IDNAME, const wxString& caption = SYMBOL_PLAYWITHVOICEDIALOG_TITLE, const wxPoint& pos = SYMBOL_PLAYWITHVOICEDIALOG_POSITION, const wxSize& size = SYMBOL_PLAYWITHVOICEDIALOG_SIZE, long style = SYMBOL_PLAYWITHVOICEDIALOG_STYLE );

    bool Create( wxMDIParentFrame* parent, wxWindowID id = SYMBOL_PLAYWITHVOICEDIALOG_IDNAME, const wxString& caption = SYMBOL_PLAYWITHVOICEDIALOG_TITLE, const wxPoint& pos = SYMBOL_PLAYWITHVOICEDIALOG_POSITION, const wxSize& size = SYMBOL_PLAYWITHVOICEDIALOG_SIZE, long style = SYMBOL_PLAYWITHVOICEDIALOG_STYLE );

     /// Destructor
    ~PlayWithVoiceDialog();

private:
    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin PlayWithVoiceDialog event handler declarations

    /// wxEVT_CLOSE_WINDOW event handler for ID_PLAYWITHVOICEDIALOG
    void OnCloseWindow( wxCloseEvent& event );

    /// wxEVT_DESTROY event handler for ID_PLAYWITHVOICEDIALOG
    void OnDestroy( wxWindowDestroyEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_MICINPUT
    void OnBitmapbuttonMicinputClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_MIC_INPUT
    void OnSliderMicInputUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_SOUNDOUTPUT
    void OnBitmapbuttonSoundoutputClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_OUTPUT
    void OnSliderOutputUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_REVERB
    void OnBitmapbuttonReverbClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_REVERB
    void OnSliderReverbUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_CHORUS
    void OnBitmapbuttonChorusClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_CHORUS
    void OnSliderChorusUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_PITCHSHIFT
    void OnBitmapbuttonPitchshiftClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_PITCHSHIFT
    void OnSliderPitchshiftUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_DISTORSION
    void OnBitmapbuttonDistorsionClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_DISTORSION
    void OnSliderDistorsionUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX_ROBOT
    void OnCheckboxRobotClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX_PHONE
    void OnCheckboxPhoneClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX_HOWLINGREDUCTION
    void OnCheckboxHowlingreductionClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_ECHODELAY
    void OnBitmapbuttonEchodelayClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_ECHODELAY
    void OnSliderEchodelayUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_ECHOPITCHSHIFT
    void OnBitmapbuttonEchopitchshiftClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_ECHOPITCHSHIFT
    void OnSliderEchopitchshiftUpdated( wxCommandEvent& event );

////@end PlayWithVoiceDialog event handler declarations

	void OnTimer(wxTimerEvent& event);

////@begin PlayWithVoiceDialog member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end PlayWithVoiceDialog member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin PlayWithVoiceDialog member variables
    wxBitmapButton* m_btnMicInput;
    wxSlider* m_sldMicInput;
    wxGauge* m_gaugeMicInput;
    wxBitmapButton* m_btnSoundOutput;
    wxSlider* m_sldOutput;
    wxGauge* m_gaugeOutput;
    wxBitmapButton* m_btnReverb;
    wxSlider* m_sldReverb;
    wxTextCtrl* m_txtReverb;
    wxSlider* m_sldChorus;
    wxTextCtrl* m_txtChorus;
    wxSlider* m_sldPitchShift;
    wxTextCtrl* m_txtPitchShift;
    wxSlider* m_sldDistorsion;
    wxTextCtrl* m_txtDistorsion;
    wxCheckBox* m_chkRobot;
    wxCheckBox* m_chkPhone;
    wxCheckBox* m_chkHowlingReduction;
    wxSlider* m_sldEchoDelay;
    wxTextCtrl* m_txtEchoDelay;
    wxSlider* m_sldEchoPitchShift;
    wxTextCtrl* m_txtEchoPitchShift;
////@end PlayWithVoiceDialog member variables
	CLogExpRange m_logExpRangeEchoDelay;
	CPVoiceActivity* m_activity;
	wxTimer* m_timer;

	// Send a wxECVT_COMMAND_SLIDER_UPDATED event
	void UpdateSliderEvent(int id);

	// Put the value of a slider into a text box
	void Slider2TextCtrl(wxSlider* slider, wxTextCtrl* tb);
	// Put the value of a slider into a text box. Float version with optional scaling factor
	void Slider2TextCtrlF(wxSlider* slider, wxTextCtrl* tb, float fact= 1.0f);
	// Show a float number in a text box
	void TextCtrlF (float v, wxTextCtrl* tb);

	// Converts sound envelope in dB (range 0,112) to VU meter scale (0,100)
//	float Envelope2VUMeter(float env);
};

#endif
    // _PLAYWITHVOICEDIALOG_H_
